AchievementDesignHell = class(Turbine.UI.Control)
function AchievementDesignHell:Constructor(handler)
    Turbine.UI.Control.Constructor(self)

    self.skillList = {
        ["Backhand Clout"] = true,
        ["Helm-crusher"] = true,
        ["Weather Blows"] = true,
        ["Helm's Hammer"] = true,
        ["Ignore Pain"] = true,
        ["Follow Me!"] = true,
        ["One for All"] = true,
        ["Bracing Guard"] = true,
        ["Plant Feet"] = true,
        ["Gut Punch"] = true,
        ["Mettle Shield"] = true,
        ["First Strike"] = true,
        ["Joy of Battle - Damage"] = true,
        ["Strike as One!"] = true,
        ["Efficient Strikes"] = true,
    }

    self.handler = handler

    self.Command = Turbine.ShellCommand()
    function self.Command:Execute()
        HardcoreHandler:GetAchievementHint("Design Hell")
    end

    Turbine.Shell.AddCommand("hardcoredesignhell", self.Command)
    ChatOutput("Use the command /hardcoredesignhell to see a list of affected skills")

    self:SetCallbacks()
end

function AchievementDesignHell:SetCallbacks()
    self.skillCallbacks = {}
    for key, value in pairs(SkillEventHandler:GetSkills()) do
        if self.skillList[key] then
            table.insert(self.skillCallbacks, AddCallback(SkillEventHandler, key, function(skill) 
                self.handler:Fail("Design Hell", "Usage of an illegal skill", 0x410E0CCE)
            end))
        end
    end
end

function AchievementDesignHell:Unload()
    for key, value in pairs(self.skillCallbacks) do
        RemoveCallback(SkillEventHandler, key, value) 
    end
end

function AchievementDesignHell:Refresh()
    self:Unload()
    self:SetCallbacks()
end


function AchievementDesignHell:GetHint()
    ChatOutput("<rgb=#005500>Only brawler skills that have a unique icon can be used.")
    ChatOutput("<rgb=#FF0000>Skills that are not allowed:")
    for key, value in PrimeUtils.Utils.spairs(self.skillList, function(t, a, b) return a < b end) do
       ChatOutput(key)
    end
end